'--- Set the path according to your system of folders
%path = "c:\mpa\W7"
%starthist = "1996:1"
%endhist = "2010:1"

cd {%path}

'----- Read quarterly data -----
workfile kalman q %starthist %endhist
delete *
read {%path}\data.xls 7

'----- Seasonal adjustment
for %i x_cpi_u 
{%i}.x12(x12(mode=m,save=d11))
rename *_u_sa *
next

'----- Compute logs and growth rates
for %i cpi gdp x_cpi x_gdp s
  series l{%i} = 100*log({%i})
  series dl_{%i} = 4*(l{%i} - l{%i}(-1))
  series d4l_{%i} = l{%i} - l{%i}(-4)
next

'------Real interest rates---------
series r = rn - d4l_cpi
series x_r = x_rn - d4l_x_cpi

'----- Real exchange rate
series lz = ls + lx_cpi - lcpi
series dl_z = 4*(lz - lz(-1))
series d4l_z = lz - lz(-4)

'----- HP Filter
for %i lgdp lz r lx_gdp x_r
{%i}.hpf {%i}_tnd_hp
series {%i}_gap_hp = {%i}-{%i}_tnd_hp
next

series dl_z_tnd_hp = 4*(lz_tnd_hp - lz_tnd_hp(-1))
series d4l_z_eu_tnd = lz_tnd_hp - lz_tnd_hp(-4)

'---- CPI target
dl_cpi.hpf dl_cpi_tar

'---- Save workfile
save kalman
close kalman
